(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var check = Package.check.check;
var Match = Package.check.Match;
var Accounts = Package['accounts-base'].Accounts;
var AccountsServer = Package['accounts-base'].AccountsServer;

/* Package-scope variables */
var AccountsUi, SandstormAccountSettingsUi;

(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                 //
// packages/sandstorm-accounts-ui/accounts-ui-server.js                                            //
//                                                                                                 //
/////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                   //
// Sandstorm - Personal Cloud Sandbox                                                              // 1
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                           // 2
// All rights reserved.                                                                            // 3
//                                                                                                 // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                 // 5
// you may not use this file except in compliance with the License.                                // 6
// You may obtain a copy of the License at                                                         // 7
//                                                                                                 // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                    // 9
//                                                                                                 // 10
// Unless required by applicable law or agreed to in writing, software                             // 11
// distributed under the License is distributed on an "AS IS" BASIS,                               // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                        // 13
// See the License for the specific language governing permissions and                             // 14
// limitations under the License.                                                                  // 15
                                                                                                   // 16
// Meteor permits users to modify their own profile by default, for some reason.                   // 17
Meteor.users.deny({                                                                                // 18
  insert: function () { return true; },                                                            // 19
  update: function () { return true; },                                                            // 20
  remove: function () { return true; },                                                            // 21
  fetch: []                                                                                        // 22
});                                                                                                // 23
                                                                                                   // 24
Meteor.publish("getMyUsage", function () {                                                         // 25
  if (this.userId) {                                                                               // 26
    // TODO(someday): Make this reactive.                                                          // 27
    var usage = this.connection.sandstormDb.getMyUsage(Meteor.users.findOne(this.userId));         // 28
    this.added("users", this.userId, {pseudoUsage: usage});                                        // 29
  }                                                                                                // 30
  this.ready();                                                                                    // 31
});                                                                                                // 32
                                                                                                   // 33
/////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                 //
// packages/sandstorm-accounts-ui/accounts-ui-methods.js                                           //
//                                                                                                 //
/////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                   //
// Sandstorm - Personal Cloud Sandbox                                                              // 1
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                           // 2
// All rights reserved.                                                                            // 3
//                                                                                                 // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                 // 5
// you may not use this file except in compliance with the License.                                // 6
// You may obtain a copy of the License at                                                         // 7
//                                                                                                 // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                    // 9
//                                                                                                 // 10
// Unless required by applicable law or agreed to in writing, software                             // 11
// distributed under the License is distributed on an "AS IS" BASIS,                               // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                        // 13
// See the License for the specific language governing permissions and                             // 14
// limitations under the License.                                                                  // 15
                                                                                                   // 16
// This file contains method definitions which are available on both client and server (on the     // 17
// client for prediction purposes, on the server for actual execution).                            // 18
                                                                                                   // 19
var ValidHandle = Match.Where(function (handle) {                                                  // 20
  check(handle, String);                                                                           // 21
  return !!handle.match(/^[a-z_][a-z0-9_]*$/);                                                     // 22
});                                                                                                // 23
                                                                                                   // 24
Meteor.methods({                                                                                   // 25
  updateProfile: function (identityId, profile) {                                                  // 26
    // TODO(cleanup): This check also appears in sandstorm-db/users.js.                            // 27
    check(identityId, String);                                                                     // 28
                                                                                                   // 29
    check(profile, {                                                                               // 30
      name: String,                                                                                // 31
      handle: ValidHandle,                                                                         // 32
      pronoun: Match.OneOf("male", "female", "neutral", "robot"),                                  // 33
      unverifiedEmail: Match.Optional(String)                                                      // 34
    });                                                                                            // 35
                                                                                                   // 36
    if (!this.userId) {                                                                            // 37
      throw new Meteor.Error(403, "not logged in");                                                // 38
    }                                                                                              // 39
                                                                                                   // 40
    var userToUpdate = Meteor.users.findOne({_id: identityId});                                    // 41
                                                                                                   // 42
    if (!this.isSimulation &&                                                                      // 43
        !this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                   // 44
      throw new Meteor.Error(403, "identity is not linked to current user: "+ identityId);         // 45
    }                                                                                              // 46
                                                                                                   // 47
    var newValues = {                                                                              // 48
      "profile.name": profile.name,                                                                // 49
      "profile.handle": profile.handle,                                                            // 50
      "profile.pronoun": profile.pronoun,                                                          // 51
    };                                                                                             // 52
                                                                                                   // 53
    Meteor.users.update({_id: userToUpdate._id}, {$set: newValues});                               // 54
                                                                                                   // 55
    if (!Meteor.user().hasCompletedSignup) {                                                       // 56
      Meteor.users.update({_id: this.userId}, {$set: {hasCompletedSignup: true}});                 // 57
    }                                                                                              // 58
  },                                                                                               // 59
                                                                                                   // 60
  testFirstSignup: function (profile) {                                                            // 61
    if (!this.userId) {                                                                            // 62
      throw new Meteor.Error(403, "not logged in");                                                // 63
    }                                                                                              // 64
                                                                                                   // 65
    Meteor.users.update(this.userId, {$unset: {hasCompletedSignup: ""}});                          // 66
  },                                                                                               // 67
});                                                                                                // 68
                                                                                                   // 69
if (Meteor.isClient) {                                                                             // 70
  window.testFirstSignup = function () {                                                           // 71
    Meteor.call("testFirstSignup");                                                                // 72
  }                                                                                                // 73
}                                                                                                  // 74
                                                                                                   // 75
if (Meteor.isServer) {                                                                             // 76
  // Methods that can't be simulated.                                                              // 77
                                                                                                   // 78
  Meteor.methods({                                                                                 // 79
    uploadProfilePicture: function (identityId) {                                                  // 80
      check(identityId, String);                                                                   // 81
      if (!this.userId || !this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {
        throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);         // 83
      }                                                                                            // 84
                                                                                                   // 85
      return this.connection.sandstormDb.newAssetUpload({                                          // 86
        profilePicture: { userId: this.userId, identityId: identityId }                            // 87
      });                                                                                          // 88
    },                                                                                             // 89
                                                                                                   // 90
    cancelUploadProfilePicture: function (id) {                                                    // 91
      check(id, String);                                                                           // 92
      this.connection.sandstormDb.fulfillAssetUpload(id);                                          // 93
    },                                                                                             // 94
                                                                                                   // 95
    setPrimaryEmail: function(email) {                                                             // 96
      check(email, String);                                                                        // 97
      if (!this.userId) {                                                                          // 98
        throw new Meteor.Error(403, "Not logged in.");                                             // 99
      }                                                                                            // 100
      var emails = SandstormDb.getUserEmails(Meteor.user());                                       // 101
      if (!_.findWhere(emails, {email: email, verified: true})) {                                  // 102
        throw new Meteor.Error(403, "Not a verified email of the current user: " + email);         // 103
      }                                                                                            // 104
                                                                                                   // 105
      Meteor.users.update({_id: this.userId}, {$set: {primaryEmail: email}});                      // 106
    },                                                                                             // 107
  });                                                                                              // 108
}                                                                                                  // 109
                                                                                                   // 110
/////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['sandstorm-accounts-ui'] = {
  AccountsUi: AccountsUi,
  SandstormAccountSettingsUi: SandstormAccountSettingsUi
};

})();

//# sourceMappingURL=sandstorm-accounts-ui.js.map
